/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the MediaCenterFileVariantCreate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MediaCenterFileVariantCreate{}

// MediaCenterFileVariantCreate struct for MediaCenterFileVariantCreate
type MediaCenterFileVariantCreate struct {
	Key *string `json:"key,omitempty"`
	FileKey *string `json:"file_key,omitempty"`
	Type *string `json:"type,omitempty"`
	Default *bool `json:"default,omitempty"`
	ValidFrom *time.Time `json:"valid_from,omitempty"`
	ValidUntil *time.Time `json:"valid_until,omitempty"`
	// File url that will be downloaded in SLACE cdn
	Url *string `json:"url,omitempty"`
	External *bool `json:"external,omitempty"`
	Translations []MediaCenterTranslation `json:"translations,omitempty"`
	FallbackLanguage *string `json:"fallback_language,omitempty"`
}

// NewMediaCenterFileVariantCreate instantiates a new MediaCenterFileVariantCreate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMediaCenterFileVariantCreate() *MediaCenterFileVariantCreate {
	this := MediaCenterFileVariantCreate{}
	return &this
}

// NewMediaCenterFileVariantCreateWithDefaults instantiates a new MediaCenterFileVariantCreate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMediaCenterFileVariantCreateWithDefaults() *MediaCenterFileVariantCreate {
	this := MediaCenterFileVariantCreate{}
	return &this
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetKey() string {
	if o == nil || IsNil(o.Key) {
		var ret string
		return ret
	}
	return *o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetKeyOk() (*string, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given string and assigns it to the Key field.
func (o *MediaCenterFileVariantCreate) SetKey(v string) {
	o.Key = &v
}

// GetFileKey returns the FileKey field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetFileKey() string {
	if o == nil || IsNil(o.FileKey) {
		var ret string
		return ret
	}
	return *o.FileKey
}

// GetFileKeyOk returns a tuple with the FileKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetFileKeyOk() (*string, bool) {
	if o == nil || IsNil(o.FileKey) {
		return nil, false
	}
	return o.FileKey, true
}

// HasFileKey returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasFileKey() bool {
	if o != nil && !IsNil(o.FileKey) {
		return true
	}

	return false
}

// SetFileKey gets a reference to the given string and assigns it to the FileKey field.
func (o *MediaCenterFileVariantCreate) SetFileKey(v string) {
	o.FileKey = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MediaCenterFileVariantCreate) SetType(v string) {
	o.Type = &v
}

// GetDefault returns the Default field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetDefault() bool {
	if o == nil || IsNil(o.Default) {
		var ret bool
		return ret
	}
	return *o.Default
}

// GetDefaultOk returns a tuple with the Default field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetDefaultOk() (*bool, bool) {
	if o == nil || IsNil(o.Default) {
		return nil, false
	}
	return o.Default, true
}

// HasDefault returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasDefault() bool {
	if o != nil && !IsNil(o.Default) {
		return true
	}

	return false
}

// SetDefault gets a reference to the given bool and assigns it to the Default field.
func (o *MediaCenterFileVariantCreate) SetDefault(v bool) {
	o.Default = &v
}

// GetValidFrom returns the ValidFrom field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetValidFrom() time.Time {
	if o == nil || IsNil(o.ValidFrom) {
		var ret time.Time
		return ret
	}
	return *o.ValidFrom
}

// GetValidFromOk returns a tuple with the ValidFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetValidFromOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ValidFrom) {
		return nil, false
	}
	return o.ValidFrom, true
}

// HasValidFrom returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasValidFrom() bool {
	if o != nil && !IsNil(o.ValidFrom) {
		return true
	}

	return false
}

// SetValidFrom gets a reference to the given time.Time and assigns it to the ValidFrom field.
func (o *MediaCenterFileVariantCreate) SetValidFrom(v time.Time) {
	o.ValidFrom = &v
}

// GetValidUntil returns the ValidUntil field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetValidUntil() time.Time {
	if o == nil || IsNil(o.ValidUntil) {
		var ret time.Time
		return ret
	}
	return *o.ValidUntil
}

// GetValidUntilOk returns a tuple with the ValidUntil field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetValidUntilOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ValidUntil) {
		return nil, false
	}
	return o.ValidUntil, true
}

// HasValidUntil returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasValidUntil() bool {
	if o != nil && !IsNil(o.ValidUntil) {
		return true
	}

	return false
}

// SetValidUntil gets a reference to the given time.Time and assigns it to the ValidUntil field.
func (o *MediaCenterFileVariantCreate) SetValidUntil(v time.Time) {
	o.ValidUntil = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *MediaCenterFileVariantCreate) SetUrl(v string) {
	o.Url = &v
}

// GetExternal returns the External field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetExternal() bool {
	if o == nil || IsNil(o.External) {
		var ret bool
		return ret
	}
	return *o.External
}

// GetExternalOk returns a tuple with the External field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetExternalOk() (*bool, bool) {
	if o == nil || IsNil(o.External) {
		return nil, false
	}
	return o.External, true
}

// HasExternal returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasExternal() bool {
	if o != nil && !IsNil(o.External) {
		return true
	}

	return false
}

// SetExternal gets a reference to the given bool and assigns it to the External field.
func (o *MediaCenterFileVariantCreate) SetExternal(v bool) {
	o.External = &v
}

// GetTranslations returns the Translations field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetTranslations() []MediaCenterTranslation {
	if o == nil || IsNil(o.Translations) {
		var ret []MediaCenterTranslation
		return ret
	}
	return o.Translations
}

// GetTranslationsOk returns a tuple with the Translations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetTranslationsOk() ([]MediaCenterTranslation, bool) {
	if o == nil || IsNil(o.Translations) {
		return nil, false
	}
	return o.Translations, true
}

// HasTranslations returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasTranslations() bool {
	if o != nil && !IsNil(o.Translations) {
		return true
	}

	return false
}

// SetTranslations gets a reference to the given []MediaCenterTranslation and assigns it to the Translations field.
func (o *MediaCenterFileVariantCreate) SetTranslations(v []MediaCenterTranslation) {
	o.Translations = v
}

// GetFallbackLanguage returns the FallbackLanguage field value if set, zero value otherwise.
func (o *MediaCenterFileVariantCreate) GetFallbackLanguage() string {
	if o == nil || IsNil(o.FallbackLanguage) {
		var ret string
		return ret
	}
	return *o.FallbackLanguage
}

// GetFallbackLanguageOk returns a tuple with the FallbackLanguage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariantCreate) GetFallbackLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.FallbackLanguage) {
		return nil, false
	}
	return o.FallbackLanguage, true
}

// HasFallbackLanguage returns a boolean if a field has been set.
func (o *MediaCenterFileVariantCreate) HasFallbackLanguage() bool {
	if o != nil && !IsNil(o.FallbackLanguage) {
		return true
	}

	return false
}

// SetFallbackLanguage gets a reference to the given string and assigns it to the FallbackLanguage field.
func (o *MediaCenterFileVariantCreate) SetFallbackLanguage(v string) {
	o.FallbackLanguage = &v
}

func (o MediaCenterFileVariantCreate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MediaCenterFileVariantCreate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	if !IsNil(o.FileKey) {
		toSerialize["file_key"] = o.FileKey
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Default) {
		toSerialize["default"] = o.Default
	}
	if !IsNil(o.ValidFrom) {
		toSerialize["valid_from"] = o.ValidFrom
	}
	if !IsNil(o.ValidUntil) {
		toSerialize["valid_until"] = o.ValidUntil
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	if !IsNil(o.External) {
		toSerialize["external"] = o.External
	}
	if !IsNil(o.Translations) {
		toSerialize["translations"] = o.Translations
	}
	if !IsNil(o.FallbackLanguage) {
		toSerialize["fallback_language"] = o.FallbackLanguage
	}
	return toSerialize, nil
}

type NullableMediaCenterFileVariantCreate struct {
	value *MediaCenterFileVariantCreate
	isSet bool
}

func (v NullableMediaCenterFileVariantCreate) Get() *MediaCenterFileVariantCreate {
	return v.value
}

func (v *NullableMediaCenterFileVariantCreate) Set(val *MediaCenterFileVariantCreate) {
	v.value = val
	v.isSet = true
}

func (v NullableMediaCenterFileVariantCreate) IsSet() bool {
	return v.isSet
}

func (v *NullableMediaCenterFileVariantCreate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMediaCenterFileVariantCreate(val *MediaCenterFileVariantCreate) *NullableMediaCenterFileVariantCreate {
	return &NullableMediaCenterFileVariantCreate{value: val, isSet: true}
}

func (v NullableMediaCenterFileVariantCreate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMediaCenterFileVariantCreate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


